﻿''
'' sampleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Imports System.Data.OleDb

Public Class Form1
    ''' <summary>
    ''' ボタンクリックイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim connection As OleDbConnection = Nothing

        Try
            '引数に接続文字列を指定
            connection = New OleDbConnection("Provider=OraOLEDB.Oracle;User Id=ユーザーID;Password=パスワード;Data Source=(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=ホスト名)(PORT=1521)))(CONNECT_DATA=(SID=ORCL)(SERVER=DEDICATED)));")

            '接続
            connection.Open()

            'ストアドファンクションの呼び出し

            'コマンド生成
            Dim command As OleDbCommand = connection.CreateCommand()
            'ストアドファンクションを呼び出すように指定
            Command.CommandType = CommandType.StoredProcedure
            '実行するストアドファンクションの名称
            command.CommandText = "FUNCTION_TEST"

            'RETURN(ストアドファンクションからの戻り値)の設定
            Dim returnValue As New OleDbParameter("return", OleDbType.Integer)
            returnValue.Direction = ParameterDirection.ReturnValue
            Command.Parameters.Add(returnValue)

            '1番目のINパラメータ
            Dim inParameter1 As OleDbParameter = New OleDbParameter("入力パラメータ1", OleDbType.Date)
            inParameter1.Value = DateTime.Now
            command.Parameters.Add(inParameter1)

            '2番目のINパラメータ
            Dim inParameter2 As OleDbParameter = New OleDbParameter("入力パラメータ2", OleDbType.VarChar)
            inParameter2.Value = "1"
            command.Parameters.Add(inParameter2)

            '3番目のOUTパラメータ
            Dim outParameter1 As New OleDbParameter("出力パラメータ1", OleDbType.VarChar, 256)
            outParameter1.Direction = ParameterDirection.Output
            Command.Parameters.Add(outParameter1)

            '実行
            Command.ExecuteNonQuery()

            '結果の表示
            MessageBox.Show(String.Format("return値=[{0}] out値=[{1}]", returnValue.Value, outParameter1.Value))

        Catch ex As Exception
            '接続失敗
            MessageBox.Show(ex.ToString, "接続エラー")
        Finally
            If connection IsNot Nothing Then
                '接続を閉じる
                connection.Close()
                connection = Nothing
            End If
        End Try
    End Sub

End Class
